/* Include files */

#include "BLDC_equals_sfun.h"
#include "BLDC_equals_sfun_debug_macros.h"
#include "c2_BLDC_equals.h"
#include "c9_BLDC_equals.h"
#include "c10_BLDC_equals.h"
#include "c15_BLDC_equals.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
uint32_T _BLDC_equalsMachineNumber_;

/* Function Declarations */

/* Function Definitions */
void BLDC_equals_initializer(void)
{
}

void BLDC_equals_terminator(void)
{
}

/* SFunction Glue Code */
unsigned int sf_BLDC_equals_method_dispatcher(SimStruct *simstructPtr, unsigned
  int chartFileNumber, const char* specsCksum, int_T method, void *data)
{
  if (chartFileNumber==2) {
    c2_BLDC_equals_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==9) {
    c9_BLDC_equals_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==10) {
    c10_BLDC_equals_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==15) {
    c15_BLDC_equals_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  return 0;
}

unsigned int sf_BLDC_equals_process_check_sum_call( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[20];
  if (nrhs<1 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the checksum */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"sf_get_check_sum"))
    return 0;
  plhs[0] = mxCreateDoubleMatrix( 1,4,mxREAL);
  if (nrhs>1 && mxIsChar(prhs[1])) {
    mxGetString(prhs[1], commandName,sizeof(commandName)/sizeof(char));
    commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
    if (!strcmp(commandName,"machine")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2577958118U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2799792193U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1908910329U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3759583350U);
    } else if (!strcmp(commandName,"exportedFcn")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0U);
    } else if (!strcmp(commandName,"makefile")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(320408279U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3629535465U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(507086388U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(193855731U);
    } else if (nrhs==3 && !strcmp(commandName,"chart")) {
      unsigned int chartFileNumber;
      chartFileNumber = (unsigned int)mxGetScalar(prhs[2]);
      switch (chartFileNumber) {
       case 2:
        {
          extern void sf_c2_BLDC_equals_get_check_sum(mxArray *plhs[]);
          sf_c2_BLDC_equals_get_check_sum(plhs);
          break;
        }

       case 9:
        {
          extern void sf_c9_BLDC_equals_get_check_sum(mxArray *plhs[]);
          sf_c9_BLDC_equals_get_check_sum(plhs);
          break;
        }

       case 10:
        {
          extern void sf_c10_BLDC_equals_get_check_sum(mxArray *plhs[]);
          sf_c10_BLDC_equals_get_check_sum(plhs);
          break;
        }

       case 15:
        {
          extern void sf_c15_BLDC_equals_get_check_sum(mxArray *plhs[]);
          sf_c15_BLDC_equals_get_check_sum(plhs);
          break;
        }

       default:
        ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0.0);
      }
    } else if (!strcmp(commandName,"target")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3031367619U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4001028638U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3978939492U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(838979348U);
    } else {
      return 0;
    }
  } else {
    ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2183334U);
    ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3477908983U);
    ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3666162406U);
    ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2756140039U);
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_BLDC_equals_autoinheritance_info( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[32];
  char aiChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the autoinheritance_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_autoinheritance_info"))
    return 0;
  mxGetString(prhs[2], aiChksum,sizeof(aiChksum)/sizeof(char));
  aiChksum[(sizeof(aiChksum)/sizeof(char)-1)] = '\0';

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        if (strcmp(aiChksum, "3DrhS1EEIPv1vunm2LowvH") == 0) {
          extern mxArray *sf_c2_BLDC_equals_get_autoinheritance_info(void);
          plhs[0] = sf_c2_BLDC_equals_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 9:
      {
        if (strcmp(aiChksum, "7SKnsoSn5Pp59Lwrb7tQlC") == 0) {
          extern mxArray *sf_c9_BLDC_equals_get_autoinheritance_info(void);
          plhs[0] = sf_c9_BLDC_equals_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 10:
      {
        if (strcmp(aiChksum, "YCcueZh1jrKcF3mIRxfhJG") == 0) {
          extern mxArray *sf_c10_BLDC_equals_get_autoinheritance_info(void);
          plhs[0] = sf_c10_BLDC_equals_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 15:
      {
        if (strcmp(aiChksum, "n1OP3uKdtuVCQEiH0MkJVD") == 0) {
          extern mxArray *sf_c15_BLDC_equals_get_autoinheritance_info(void);
          plhs[0] = sf_c15_BLDC_equals_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_BLDC_equals_get_eml_resolved_functions_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[64];
  if (nrhs<2 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the get_eml_resolved_functions_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_eml_resolved_functions_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        extern const mxArray *sf_c2_BLDC_equals_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c2_BLDC_equals_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 9:
      {
        extern const mxArray *sf_c9_BLDC_equals_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c9_BLDC_equals_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 10:
      {
        extern const mxArray *sf_c10_BLDC_equals_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c10_BLDC_equals_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 15:
      {
        extern const mxArray *sf_c15_BLDC_equals_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c15_BLDC_equals_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_BLDC_equals_third_party_uses_info( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{
  char commandName[64];
  char tpChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the third_party_uses_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  mxGetString(prhs[2], tpChksum,sizeof(tpChksum)/sizeof(char));
  tpChksum[(sizeof(tpChksum)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_third_party_uses_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        if (strcmp(tpChksum, "w3uIDdA7FHxrmhqbrtOo5") == 0) {
          extern mxArray *sf_c2_BLDC_equals_third_party_uses_info(void);
          plhs[0] = sf_c2_BLDC_equals_third_party_uses_info();
          break;
        }
      }

     case 9:
      {
        if (strcmp(tpChksum, "48UNHXqKmbaNvAfNfkaUjF") == 0) {
          extern mxArray *sf_c9_BLDC_equals_third_party_uses_info(void);
          plhs[0] = sf_c9_BLDC_equals_third_party_uses_info();
          break;
        }
      }

     case 10:
      {
        if (strcmp(tpChksum, "xDqH9Ct7U4DK6b58ViYA3C") == 0) {
          extern mxArray *sf_c10_BLDC_equals_third_party_uses_info(void);
          plhs[0] = sf_c10_BLDC_equals_third_party_uses_info();
          break;
        }
      }

     case 15:
      {
        if (strcmp(tpChksum, "3iOY05qk7M5oMZRdL2jQ5F") == 0) {
          extern mxArray *sf_c15_BLDC_equals_third_party_uses_info(void);
          plhs[0] = sf_c15_BLDC_equals_third_party_uses_info();
          break;
        }
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;
}

unsigned int sf_BLDC_equals_updateBuildInfo_args_info( int nlhs, mxArray * plhs[],
  int nrhs, const mxArray * prhs[] )
{
  char commandName[64];
  char tpChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the updateBuildInfo_args_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  mxGetString(prhs[2], tpChksum,sizeof(tpChksum)/sizeof(char));
  tpChksum[(sizeof(tpChksum)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_updateBuildInfo_args_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        if (strcmp(tpChksum, "w3uIDdA7FHxrmhqbrtOo5") == 0) {
          extern mxArray *sf_c2_BLDC_equals_updateBuildInfo_args_info(void);
          plhs[0] = sf_c2_BLDC_equals_updateBuildInfo_args_info();
          break;
        }
      }

     case 9:
      {
        if (strcmp(tpChksum, "48UNHXqKmbaNvAfNfkaUjF") == 0) {
          extern mxArray *sf_c9_BLDC_equals_updateBuildInfo_args_info(void);
          plhs[0] = sf_c9_BLDC_equals_updateBuildInfo_args_info();
          break;
        }
      }

     case 10:
      {
        if (strcmp(tpChksum, "xDqH9Ct7U4DK6b58ViYA3C") == 0) {
          extern mxArray *sf_c10_BLDC_equals_updateBuildInfo_args_info(void);
          plhs[0] = sf_c10_BLDC_equals_updateBuildInfo_args_info();
          break;
        }
      }

     case 15:
      {
        if (strcmp(tpChksum, "3iOY05qk7M5oMZRdL2jQ5F") == 0) {
          extern mxArray *sf_c15_BLDC_equals_updateBuildInfo_args_info(void);
          plhs[0] = sf_c15_BLDC_equals_updateBuildInfo_args_info();
          break;
        }
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;
}

void BLDC_equals_debug_initialize(struct SfDebugInstanceStruct* debugInstance)
{
  _BLDC_equalsMachineNumber_ = sf_debug_initialize_machine(debugInstance,
    "BLDC_equals","sfun",0,4,0,0,0);
  sf_debug_set_machine_event_thresholds(debugInstance,_BLDC_equalsMachineNumber_,
    0,0);
  sf_debug_set_machine_data_thresholds(debugInstance,_BLDC_equalsMachineNumber_,
    0);
}

void BLDC_equals_register_exported_symbols(SimStruct* S)
{
}

static mxArray* sRtwOptimizationInfoStruct= NULL;
mxArray* load_BLDC_equals_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct==NULL) {
    sRtwOptimizationInfoStruct = sf_load_rtw_optimization_info("BLDC_equals",
      "BLDC_equals");
    mexMakeArrayPersistent(sRtwOptimizationInfoStruct);
  }

  return(sRtwOptimizationInfoStruct);
}

void unload_BLDC_equals_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct!=NULL) {
    mxDestroyArray(sRtwOptimizationInfoStruct);
    sRtwOptimizationInfoStruct = NULL;
  }
}
